class V1::SearchController < ApplicationController
  before_action :set_search

  # GET v1/search
  # GET v1/search.json
  def index
    render json: ActiveModel::ArraySerializer.new(SearchService.search(@search, current_user)), status: :ok
  rescue => e
    if e.message == 'Invalid search'
      render json: @search.errors, status: :bad_request
    else
      render nothing: true, status: :internal_server_error
    end
  end

  # GET v1/search/autocomplete
  # GET v1/search/autocomplete.json
  def autocomplete
    render json: ActiveModel::ArraySerializer.new(SearchService.autocomplete(@search, current_user)), status: :ok
  rescue => e
    if e.message == 'Invalid search'
      render json: @search.errors, status: :bad_request
    else
      render nothing: true, status: :internal_server_error
    end
  end

  private

  def set_search
    @search = Search.new(params)
  end
end
